var spyOnComponent = require('spy-on-component');

module.exports = function createTimeoutManager(componentInstance) {
  var unmounted = false;
  var timers = Object.create(null);

  spyOnComponent(componentInstance, {
    componentWillUnmount: function() {
      unmounted = true;

      for (var k in timers) clearTimeout(timers[k])
      timers = null;
    }
  })

  return {
    clear: function(key) {
      clearTimeout(timers[key])
    },

    set: function(key, fn, ms) {
      if (unmounted) return
      timers[key] = setTimeout(fn, ms)
    }
  }
}
